{% extends 'appPrueba/plantilla.html' %}

{% load static %}

{% block content %}

<div class="col-md-8 col-lg-6 col-sm-12 mx-auto">
    <h3 style="text-align: center; margin-bottom: 3%;">Vota por tu imagen favorita</h3>
    {% for imagen in imagenes %}
        <div class="card mb-4">
            <div class="card-body">            
                <h5 class="card-title" align="center">Nickname: {{imagen.nickname}}</h5>
                <h5 class="card-title" align="center">Nombre: {{imagen.nombre}}</h5>
                {% if imagen.flip %}
                    {% if imagen.angulo == 0 %}
                    <div name="imgContainer" class="flipX">
                        <img src="{{imagen.foto.url}}" alt="{{imagen.nombre}}" name="0" width="100%">
                    </div>
                    {% elif imagen.angulo == 90 %}
                    <div name="imgContainer" class="rotate90 flipX">
                        <img src="{{imagen.foto.url}}" alt="{{imagen.nombre}}" name="90" width="100%">
                    </div>
                    {% elif imagen.angulo == 180 %}
                    <div name="imgContainer" class="rotate180 flipX">
                        <img src="{{imagen.foto.url}}" alt="{{imagen.nombre}}" name="180" width="100%">
                    </div>
                    {% elif imagen.angulo == 270 %}
                    <div name="imgContainer" class="rotate270 flipX">
                        <img src="{{imagen.foto.url}}" alt="{{imagen.nombre}}" name="270" width="100%">
                    </div>
                    {% endif %}
                {% else %}
                    {% if imagen.angulo == 0 %}
                    <div name="imgContainer">
                        <img src="{{imagen.foto.url}}" alt="{{imagen.nombre}}" name="0" width="100%">
                    </div>
                    {% elif imagen.angulo == 90 %}
                    <div name="imgContainer" class="rotate90">
                        <img src="{{imagen.foto.url}}" alt="{{imagen.nombre}}" name="90" width="100%">
                    </div>
                    {% elif imagen.angulo == 180 %}
                    <div name="imgContainer" class="rotate180">
                        <img src="{{imagen.foto.url}}" alt="{{imagen.nombre}}" name="180" width="100%">
                    </div>
                    {% elif imagen.angulo == 270 %}
                    <div name="imgContainer" class="rotate270">
                        <img src="{{imagen.foto.url}}" alt="{{imagen.nombre}}" name="270" width="100%">
                    </div>
                    {% endif %}
                {% endif %}
                <div align="center">
                    <button class="btn btn-danger form-control" type="button" id="{{imagen.id}}" onclick="checkUser(id)"><i class="fas fa-heart"></i></button>
                    <label id="votos{{imagen.id}}" style="text-align: center; margin-bottom: 3%;">Likes: {{imagen.votos}}</label>
                </div>
            </div>
        </div>
    {% endfor %}

</div>

{% if not user.is_authenticated %}

<!-- Modal -->
<div class="modal fade" id="modal" role="dialog">
    <div class="modal-dialog">
        <!-- Modal content-->
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title">Inicia sesión para votar</h4>
                <button type="button" class="close" data-dismiss="modal">&times;</button>
            </div>
            <div class="modal-body">
                <div class="col-lg-12">
                    <div class="panel panel-info">
                        <div style="text-align: center">
                            <h2>Iniciar sesión</h2>
                        </div>
                        <div>
                            <form class="form1" action="{% url 'iniciarSesion' %}" method="post" enctype="multipart/form-data">
                                {% csrf_token %}
                                <div class="form-group">
                                    <input type="text" name="username" class="form-control" placeholder="Nombre de usuario" required>
                                </div>
                                <div class="form-group">
                                    <input type="password" name="password" id="password" class="form-control" placeholder="Contraseña" required>
                                </div>
                                <div class="form-group">
                                    <input type="submit" name="submit" value="Iniciar Sesión" class="form-control btn btn-primary">
                                </div>
                            </form>
                            <div class="col-md-12" style="text-align: center;">
                                <a href="{% url 'registrarUsuario' %}">¿No tienes cuenta? Regístrate</a>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
{% else %}
<input id="idUser" value="{{user.id}}" hidden>
<input id="usuarioVoto" value="{{voto}}" hidden>
{% endif %}

{% endblock content %}

{% block extrajs %}

<script>

ready = false;

$(document).ready(function(){
    if($('#usuarioVoto').val() == 1){
        $('.btn').prop('disabled', true);
    }

    $('img').each(function(){

        width = parseFloat($(this).css('width').replace('px',''));
        height = parseFloat($(this).css('height').replace('px',''));
        console.log(width, height)
        if(width > height) aux = true;
        else aux = false;
        angle = parseInt($(this).prop('name'));
        if(angle > 0){
            parent = $(this).parent()
            parent.addClass("rotate" + angle);
            if(parent.css('width') == parent.css('height')){
                parent.css({'width': width.toString()+'px', 'height': height.toString()+'px'})
            }else{
                height = width * width/height;
                parent.css({'width': width.toString()+'px', 'height': height.toString()+'px'})
                if(aux){
                    if(width > height){
                        $(this).css({'width': width.toString()+'px', 'height': height.toString()+'px'})
                    }else{
                        $(this).css({'width': height.toString()+'px', 'height': width.toString()+'px'})
                    }
                }else{
                    if(width < height){
                        $(this).css({'width': width.toString()+'px', 'height': height.toString()+'px'})
                    }else{
                        $(this).css({'width': height.toString()+'px', 'height': width.toString()+'px'})
                    }
                }
            }
        }     
    });
});

function checkUser(id){
    if($('#idUser').length > 0){
        $.ajax({
            url: "{% url 'sumarVoto' %}",
            data: {
                'idImagen': id
            },
            dataType: 'json',
            success: function (data) {
                if(data){
                    if(data['status'] == 1){
                        $('#votos'+id).html('Votos: '+data['n']);
                        $('.btn').prop('disabled', true);
                    }
                }
            }
        });
    }else{
        $('#modal').modal();
    }
}

</script>

{% endblock extrajs %}
